        PAGE ,132
        TITLE FIB is a Fibonacci test, not a small lie.
        NAME FIB

        COMMENT *
11 February 2010, small Fibonacci number sequence generator.  I
woke up way too early this morning...
12, 17 Feb, comment updates and 'minor' corrections.  I started writing
and commenting for a beginner audience, but slipped from that somewhat
while fixing it so it would run correctly.
SRN             *

; - - - EQUates - - -

Safer   EQU     1       ; If EXE2BIN not used by accident and so forth.
MaxLoop EQU     747     ; If .GT. 346 exercizes overflow test.
NoZero  EQU     1       ;    Suppress leading zeroes as Dave does.
                        ; Excess code versus asthetics?
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CODE    SEGMENT 'CODE'
        ASSUME  CS:CODE, DS:CODE, ES:CODE

        ORG     100H	; COM file opening.
Start   PROC

IF Safer
        MOV     AX,CS
        MOV     DS,AX
        MOV     ES,AX
ENDIF
        MOV     DX,OFFSET SignOn
        MOV     AH,9    ; Console String Output.
        INT     21H     ; DOS Function Interrupt.

        CALL DispFib    ; Display starting value.

        MOV     CX,MaxLoop

Strt_1:
        PUSH    CX      ; Save loop count.

        CALL CopyIt     ; Move new values over old values.
        CALL AddIt      ; F(n) + F(n+1) => F(n+2).
        TEST    AH,0FFH ; Check for array overflow.
        JNZ     Strt_3  ; Too big?  Exit.

        CALL DispFib    ; Otherwise display current value.

        MOV     AH,10H  ; Read Extended Keyboard Input.
        INT     16H     ; {Just used for a pause or an escape.}

        CMP     AL,1BH
        JZ      Strt_2  ; ESC = abort.

        POP     CX      ; Restore count.
        LOOP    Strt_1

Strt_2:
        MOV     AX,04C00H ; DOS 2.0+ exit with return code of 0 for no error.
        INT     21H

Strt_3:
        MOV     AX,04C01H ; DOS 2.0+ exit with return code of 1 to flag error.
        INT     21H

Start   ENDP

; - - - Data area.  Might be clearer to break out labels from array? - - -

SignOn  DB      13, 10, 20 DUP(' '), ' Fibonacci Number Sequence '
        DB      13, 10, 13, 10, '$'
Source1 DB      '#000, ', 72 DUP(0)     ; Low digits at +3, +77.
Source2 DB      '#000, ', 72 DUP(0)
Destin  DB      '#001, ', 71 DUP(0), 1  ; Start value.

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;    Update arrays for next addition.  Note:  This started out
; much more complicated.  If I knew it would end up like this
; it would have been in-lined.

CopyIt  PROC

        MOV     SI, OFFSET Source2
        MOV     DI, OFFSET Source1
        MOV     CX,156  ; Even, so I could do half as many words.
    REP MOVSB           ; But, what the heck, why muddy things.

        RET

CopyIt  ENDP

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;    Destination = Source 1 + Source 2.  All three arrays are maintained
; as unpacked BCD numbers.

AddIt   PROC

                ;    Go backwards starting with the little digit.  If the
        STD     ; array was stored little endian, this isn't needed here.
                ; But then everything looks backward, and then a STD will
                ; be needed in the display routine.

        MOV     DI, OFFSET Destin+77
        MOV     SI, OFFSET Source1+77
        MOV     BX, OFFSET Source2+77
        MOV     CX,71

        LODSB           ; Get first byte, increment SI to point to next.
        MOV     AH,AL

Add_1:
        LODSB           ; Get next byte.
        XCHG    AH,AL   ; Next in AH, current in AL.

        ADD     AL,[BX] ; AL = F(n) + F(n+1).
        AAA             ; ASCII adjust after addition, a carry increments AH.
        STOSB           ; Store adjusted sum to current digit and point to next.
        DEC     BX      ; And point to next source #2 digit.

        LOOP    Add_1

        MOV     AL,AH   ; Current in AL.
        XOR     AH,AH
        ADD     AL,[BX] ; And do last byte summation.
        AAA             ; Unpacked BCD adjust, a carry overflows the array.
        STOSB

; - - - Have finished the array addition, increment count for display. - - -
;;        PUSH    AX      ; Preserve AH for overflow test.  (OBE, was going to use AAA.)

        INC     BYTE PTR [Destin+3]     ; Increment LSD count in label.
        CMP     BYTE PTR [Destin+3],'9' ; Did we get too big?
        JBE     Add_2

        MOV     BYTE PTR [Destin+3],'0' ; Fix and do next larger digit in
        INC     BYTE PTR [Destin+2]     ; the same way.
        CMP     BYTE PTR [Destin+2],'9'
        JBE     Add_2

        MOV     BYTE PTR [Destin+2],'0' ; And so forth.
        INC     BYTE PTR [Destin+1]

Add_2:
;;        POP     AX

        CLD             ; Please play nicely (restore to default).

        RET

AddIt   ENDP

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; Display our result from the destination array to the console.
DispFib PROC

        MOV     SI,OFFSET Destin
        MOV     CX,6    ; Display the leading label as is.
DF_1:
        LODSB
        MOV     DL,AL

        MOV     AH,2    ; Console Character Output.
        INT     21H     ; DOS Function Interrupt.
        LOOP    DF_1

        MOV     CX,72   ; Convert and display the digits of the number.

IF NoZero               ; Supress leading zeroes since Dave does.
DF_2:
        LODSB
        TEST    AL,0FFH ; Is it empty?
        JNZ     DF_4

        CMP     CX,1    ; Run out?  (Can't happen in this program.)
        JZ      DF_4

        MOV     DL,' '  ; Display a blank to right align numbers.
        MOV     AH,2
        INT     21H

        LOOP    DF_2
ENDIF

DF_3:
        LODSB
DF_4:
        MOV     DL,AL
        ADD     DL,'0'  ; Convert binary digit to ASCII and display.
        MOV     AH,2
        INT     21H

        LOOP    DF_3

; Scroll display.
        MOV     DL,13   ; Carriage Return.
        MOV     AH,2
        INT     21H

        MOV     DL,10   ; Linefeed.
        MOV     AH,2
        INT     21H

        RET

DispFib ENDP

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CODE    ENDS
        END     Start
